package com.trs.ggzyexchange.schedul;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.trs.ggzyexchange.api.vo.Result;
import com.trs.ggzyexchange.controller.BaseController;
import com.trs.ggzyexchange.entity.CqSwBargainResult;
import com.trs.ggzyexchange.entity.GcBidcandidatePost;
import com.trs.ggzyexchange.entity.ScheduledTash;
import com.trs.ggzyexchange.entity.TenderDetailsVo;
import com.trs.ggzyexchange.enums.ClassIfy;
import com.trs.ggzyexchange.enums.JobLock;
import com.trs.ggzyexchange.service.CqSwBargainResultService;
import com.trs.ggzyexchange.service.GcNoticeandfileService;
import com.trs.ggzyexchange.service.ScheduledTashService;
import com.trs.ggzyexchange.service.TenderDetailsVoService;
import com.trs.ggzyexchange.utils.TenderDetailsVoUtils;
import org.apache.commons.lang3.ObjectUtils;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * 交易结果信息 前端控制器
 * </p>
 *
 * @author trs
 * @since 2023-03-03
 */
@Component
public class CqSwBargainResultSchedul implements Job {

    private Logger logger = LoggerFactory.getLogger(CqSwBargainResultSchedul.class);

    @Autowired
    private CqSwBargainResultService cqSwBargainResultService;

    @Autowired
    private GcNoticeandfileService gcNoticeandfileService;

    @Autowired
    private TenderDetailsVoService tenderDetailsVoService;

    @Autowired
    private ScheduledTashService scheduledTashService;

    public void queryPageListUpdateEs() throws JsonProcessingException {
        //查询当前在定时任务表当中的时间
        QueryWrapper<ScheduledTash> scheduledTashQueryWrapper = new QueryWrapper<ScheduledTash>();
        scheduledTashQueryWrapper.eq("table_name_value","cq_sw_bargain_result");
        Page<ScheduledTash> pageScheduledTash = new Page<ScheduledTash>(1, 1);
        Page<ScheduledTash> page = scheduledTashService.page(pageScheduledTash, scheduledTashQueryWrapper);
        List<ScheduledTash> records = page.getRecords();
        ScheduledTash scheduledTash = null;
        if(records.size() > 0){
            scheduledTash = records.get(0);
        }
        Long time = null;
        if(ObjectUtils.isEmpty(scheduledTash)){
            try {
                //查询表gcNoticeandfile表当中的最新时间
                time = cqSwBargainResultService.maxDataTimeStamp();
                ScheduledTash scheduledTashTash = new ScheduledTash();
                scheduledTashTash.setTime(time);
                scheduledTashTash.setTableNameValue("cq_sw_bargain_result");
                scheduledTashTash.setUpdateTime(new Date());
                scheduledTashTash.setCreateTime(new Date());
                scheduledTashService.saveOrUpdate(scheduledTashTash,scheduledTashQueryWrapper);
            }catch (Exception e){
                e.printStackTrace();
            }
        }else {
            time = scheduledTash.getTime();
        }
        try {
            //查询表gcNoticeandfile表当中的最新时间
            Long newTime = cqSwBargainResultService.maxDataTimeStamp();
            ScheduledTash scheduledTashTash = new ScheduledTash();
            scheduledTashTash.setTime(newTime);
            scheduledTashTash.setTableNameValue("cq_sw_bargain_result");
            scheduledTashTash.setUpdateTime(new Date());
            scheduledTashService.saveOrUpdate(scheduledTashTash,scheduledTashQueryWrapper);
        }catch (Exception e){
            e.printStackTrace();
        }
        try {
            if(!ObjectUtils.isEmpty(time)){
                QueryWrapper<CqSwBargainResult> gcBidcandidatePostQueryWrapper = new QueryWrapper<CqSwBargainResult>();
                gcBidcandidatePostQueryWrapper.gt("DATA_TIMESTAMP",time);
                int count = cqSwBargainResultService.count(gcBidcandidatePostQueryWrapper);
                Integer pageSize = 1000;
                Integer pageNum = (int)Math.ceil((double)count/pageSize);
                for(int i = 1; i <= pageNum;i++){
                    try {
                        List<TenderDetailsVo> tenderDetailsVoListAll = getTenderDetailsVoListAll(i, pageSize,time);
                        Boolean aBoolean = gcNoticeandfileService.parseTenderDetailsVo(tenderDetailsVoListAll);
                    }catch (Exception e){
                        e.printStackTrace();
                    }
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }

    }
    public List<TenderDetailsVo> getTenderDetailsVoListAll(Integer pageNo,Integer pageSize,Long time){
        Page<CqSwBargainResult> page = new Page<CqSwBargainResult>(pageNo, pageSize);
        IPage<TenderDetailsVo> tenderDetailsVoIPage = cqSwBargainResultService.queryCqSwBargainResultAllListByTime(page,time);
        for (TenderDetailsVo record : tenderDetailsVoIPage.getRecords()) {
            try {
                record.setNoticeTypeCode(ClassIfy.TRANSACTION_RESULTS.getCode());
                record.setNoticeTypeName(ClassIfy.TRANSACTION_RESULTS.getName());
                record.setTransactionTypeCode(ClassIfy.STATE_OWNED_PROPERTY_RIGHTS.getCode());
                record.setTransactionTypeName(ClassIfy.STATE_OWNED_PROPERTY_RIGHTS.getName());
                record = tenderDetailsVoService.getTenderDetailsVoAllOrther(record);
                TenderDetailsVoUtils.isNull(record);
            }catch (Exception e){
                e.printStackTrace();
            }
        }
        return tenderDetailsVoIPage.getRecords();
    }

    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        try {
            if(JobLock.CqSwBargainResultFlag){
                JobLock.CqSwBargainResultFlag = false;
                logger.info("执行CqSwBargainResult", new SimpleDateFormat().format(new Date()));
                try {
                    queryPageListUpdateEs();
                } catch (JsonProcessingException e) {
                    e.printStackTrace();
                }
                JobLock.CqSwBargainResultFlag = true;
            }else{
                logger.info("不执行CqSwBargainResult", new SimpleDateFormat().format(new Date()));
            }
        }catch (Exception e){
            e.printStackTrace();
        }

    }
}
